/**

 * @package 
 * @version 1.0.4 
 * @author Jason Lau
 * @link http://jasonlau.biz
 * @copyright 2011
 * @license GNU/GPL 3+
 * @uses WordPress

Plugin Name: Visitor Maps Extended Referer
Plugin URI: http://jasonlau.biz
Description: This WordPress plugin extends and depends on the <a href="http://www.642weather.com/weather/scripts-wordpress-visitor-maps.php" target="_blank">Visitor Maps and Who's Online</a> plugin by <a title="Visit author homepage" href="http://www.642weather.com/weather/scripts.php" target="_blank">Mike Challis</a>. This plugin alters the <em>Referer</em> column for the Admin's <em>Who's Been Online</em> grid, so it displays the referring host name followed by the search string, if there is one. It also prevents long URLs from expanding the grid too wide for viewing. There are no settings required.
Author: Jason Lau
Version: 1.0.4
Author URI: http://jasonlau.biz
*/

jQuery(function($){

    var LINK_MAX_WIDTH = 400,

    getHostname = function(str) {
        var re = new RegExp('^(?:f|ht)tp(?:s)?\://([^/]+)', 'im');
        return str.match(re)[1].toString();
    },

    getUrlVars = function(original_link){
        var vars = {};
        var parts = original_link.replace(/[?&]+([^=&]+)=([^&]*)/gi, function(m,key,value){
            vars[key] = value;
        });
        return vars;
    },
    
    base64_encode = function(data){

    var b64 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
    var o1, o2, o3, h1, h2, h3, h4, bits, i = ac = 0, enc="", tmp_arr = [];

    if (!data) {
        return data;
    }

    data = utf8_encode(data+'');
    
    do {
        o1 = data.charCodeAt(i++);
        o2 = data.charCodeAt(i++);
        o3 = data.charCodeAt(i++);

        bits = o1<<16 | o2<<8 | o3;

        h1 = bits>>18 & 0x3f;
        h2 = bits>>12 & 0x3f;
        h3 = bits>>6 & 0x3f;
        h4 = bits & 0x3f;

        tmp_arr[ac++] = b64.charAt(h1) + b64.charAt(h2) + b64.charAt(h3) + b64.charAt(h4);
    } while (i < data.length);
    
    enc = tmp_arr.join('');
    
    switch( data.length % 3 ){
        case 1:
            enc = enc.slice(0, -2) + '==';
        break;
        case 2:
            enc = enc.slice(0, -1) + '=';
        break;
    }

    return enc;
    },
    
    utf8_encode = function(argString) {
        
    var string = (argString+''),
    utftext = "",
    start, end,
    stringl = 0;

    start = end = 0;
    stringl = string.length;
    for (var n = 0; n < stringl; n++) {
        var c1 = string.charCodeAt(n);
        var enc = null;

        if (c1 < 128) {
            end++;
        } else if (c1 > 127 && c1 < 2048) {
            enc = String.fromCharCode((c1 >> 6) | 192) + String.fromCharCode((c1 & 63) | 128);
        } else {
            enc = String.fromCharCode((c1 >> 12) | 224) + String.fromCharCode(((c1 >> 6) & 63) | 128) + String.fromCharCode((c1 & 63) | 128);
        }
        if (enc !== null) {
            if (end > start) {
                utftext += string.substring(start, end);
            }
            utftext += enc;
            start = end = n+1;
        }
    }

    if (end > start) {
        utftext += string.substring(start, string.length);
    }

    return utftext;
    };

    if(getUrlVars(window.location.href)["page"] == 'whos-been-online'){            
    $("font[color='green'] a").each(function(){       
        var original_link = $(this).attr("href");
        var q = getUrlVars(original_link)["q"];
        if(!q && getUrlVars(original_link)["p"]){
            q = getUrlVars(original_link)["p"];
        }

        if(original_link){
            if(q){
                var original_query = q;
                q = q.replace(/%20|%2B|\+/gi, " ");
                q = q.replace(/%3E|%3C/gi,"");
                $(this).html(getHostname(original_link).replace(/www./gi, " "));
                $(this).after(' <a style="color: green; text-decoration: none;border-bottom: 1px dashed green;" href="https://www.google.com/#hl=en&safe=on&output=search&sclient=psy-ab&q=' + original_query + '" target="_blank" title="Search Google for ' + unescape(q) + '">' + unescape(q) + '</a>');
            } else {
                $(this).html(getHostname(original_link).replace(/www./gi, " "));
            }
            $(this).attr({"href" : "http://2ho.me/?link=" + base64_encode(original_link)});           
        }                
    });  

    $(".table-top td:contains('Referer')").append(" & Search String");    
    $(".column-dark td:contains(a), .column-light td:contains(a)").each(function(){
        $(this).wrapInner('<div style="max-width:' + LINK_MAX_WIDTH + 'px; overflow:hidden; padding:0px; margin:0px"></div>');
    });    
    }

});   